#include <bits\stdc++.h>
using namespace std;

char a[100000];
string eng = "", perm;
int n, k, nsize = 2, kn;

bool Found(int size, int r){
	int i = 0;
	for(int j = 0; j < r; j++){
		while(a[j+i] == perm[i]){
			if(i == size)return true;
			i++;
		}
		i = 0;
	}
	return false;
}


void Search(int r){
	perm = eng;
	while(Found(nsize-1, r-nsize+1)){
		if(!next_permutation(perm.begin(), perm.begin()+kn)){
			nsize++;
		}
	}
	
	cout << nsize;
	return;
}

int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int i, j;
	cin >> n >> k;
	char bong = 'a';
	for(i = 0; i < k; i++){
		for(j = 0; j < n; j++){
			eng+= bong;
		}
		bong++;
	}
	
	kn = n*k;
	for(i = 0; i < n; i++){
		cin >> a[i];
	}
	for(j = 1; j < k; j++){
		cout << 1;
	}
	
	for(i = j; i <= n; i++){
		Search(i);
	}
	
	return 0;
}